// De: "Apuntes de Informtica Industrial" Carlos Platero.
// Ver permisos en licencia de GPL
//
//Ejemplo del patrn GoF de adaptador
//Desde un generador de nmeros de Fibonnaci, dado en FibonacciGenerator.h,
//Adaptacin para emplear las STL
//Cdigo de prueba (XP)

#include <iostream>
#include "AdaptadorFibonacci.h"
#include <numeric>
#include <algorithm>

IAdaptadorFibonacci* IAdaptadorFibonacci::factoriaFibonacci(unsigned grado)
{
	return (new AdaptadorFibonacci(grado));
 
}
using namespace std;

void imprimir(unsigned);

int main() 
{
  const unsigned numeroFibo = 40;
  IAdaptadorFibonacci *pAdaptadorFibo = 
	  IAdaptadorFibonacci::factoriaFibonacci(numeroFibo);

  cout << "Tabla de Fibonacci" <<endl;
  cout << "------------------" <<endl;

  for_each(pAdaptadorFibo->getSerie().begin(),pAdaptadorFibo->getSerie().end(),
	  imprimir);
  //Ver GRASP "No hable con extraos" y el cdigo maduro

  cout << "Valor acumulado total: "
    << accumulate(pAdaptadorFibo->getSerie().begin(), 
					pAdaptadorFibo->getSerie().end(), 0) << endl;
  return 0;
  
}

void imprimir(unsigned numFibo)
{
	static unsigned indice;
	cout << indice++ << ": " << numFibo <<endl;
}

