// De: "Apuntes de Informtica Industrial" Carlos Platero.
// Ver permisos en licencia de GPL
//
// Ejemplo de adaptador GoF entre el generador de Fibonacci
// y las libreras STL
#ifndef _ADAPTADOR_FIBO_INC_
#define _ADAPTADOR_FIBO_INC_

#include <vector>
#include "FibonacciGenerator.h"

class IAdaptadorFibonacci
{
public:
	virtual std::vector<unsigned> & getSerie() = 0;
    static IAdaptadorFibonacci *factoriaFibonacci(unsigned grado);
};



class AdaptadorFibonacci: public IAdaptadorFibonacci
{
    FibonacciGenerator f;
    unsigned tamanyo;
	std::vector<unsigned> elVectorFibon;
	friend class IAdaptadorFibonacci;
    AdaptadorFibonacci(unsigned num): tamanyo(num)
	  {
          for (unsigned i=0;i<=tamanyo;i++)
			  elVectorFibon.push_back(f());
	  }

  public:
	  virtual std::vector<unsigned> & getSerie()
	  {return elVectorFibon;}
};

#endif
